/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

import java.util.Iterator;

public class AddArrayOptimizers {
	public static void work(HighlevelConfiguration conf, CommandLineOptions cmdLine) {
		ArrayOptimizer a;

		if (conf.getCounterCount() > 0) {
			a = new ArrayOptimizer("CntrMaxValue", "CounterType", "TickType", !cmdLine.isDefined("saveram"));
			for(Iterator<HighlevelConfiguration_Counter> it=conf.getCounterIterator(); it.hasNext(); ) {
				HighlevelConfiguration_Counter ctr = it.next();
				a.addValue(ctr.getInternalID(), ctr.getMaxValue());
			}
			conf.addArrayOptimizer(a);

			a = new ArrayOptimizer("CntrTickMaxValue", "CounterType", "TickType", !cmdLine.isDefined("saveram"));
			for(Iterator<HighlevelConfiguration_Counter> it=conf.getCounterIterator(); it.hasNext(); ) {
				HighlevelConfiguration_Counter ctr = it.next();
				a.addValue(ctr.getInternalID(), ctr.getTicksPerBase());
			}
			conf.addArrayOptimizer(a);
		}

		if (conf.getISRCount() > 0 && cmdLine.getArchitecture().hasISRLevels()) {
			a = new ArrayOptimizer("ISRFunction", "unsigned char", "ISRFunctionType", !cmdLine.isDefined("saveram"));
			conf.ISRLevels.getArray(a);
			conf.addArrayOptimizer(a);
		}
	}
}
