/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;
import java.util.Vector;

public class Attribute {
	String lValue;
	Attribute parent;
	Vector children;

	public Attribute(Attribute parent, String lValue) {
		this.parent = parent;
		this.lValue = lValue;
		this.children = new Vector();
		if (parent != null) parent.addChild(this);
	}

	public void addChild(Attribute child) {
		children.addElement(child);
	}

	private void spacing(int level) {
		for (int i = 0; i < (level + 1); i++) System.out.print("   ");
	}

	public void dumpAttribute(int level) {
		for (int i = 0; i < children.size(); i++) {
			Attribute currentAttribute = (Attribute)children.get(i);
			spacing(level);
			System.out.println(currentAttribute);
			currentAttribute.dumpAttribute(level + 1);
		}
	}

	public void dumpAttribute() {
		System.out.println(this);
		dumpAttribute(0);
	}
}

