/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

import java.io.*;
import java.util.Iterator;

public class CodeHook_osc_alarms extends CodeHook_Standard {
	public void fireImmediately() {
		if (conf.getAlarmCount() == 0) return;

		SSingleton.setIndent(2);
		SSingleton.clear();
		
		if(conf.getCounterCount()==1) {
			HighlevelConfiguration_Counter ctr = conf.getCounterIterator().next();
			genAlarmActions(ctr);
		} else {
			SSingleton.addNL("switch(i) {");
			SSingleton.incIndent();
			for(Iterator<HighlevelConfiguration_Counter> it=conf.getCounterIterator();
					it.hasNext(); ) {
				HighlevelConfiguration_Counter ctr = it.next();
				SSingleton.addNL("case " + ctr.getName() + ":");
				SSingleton.incIndent();
				genAlarmActions(ctr);
				SSingleton.addNL("break;");
				SSingleton.decIndent();
			}
			SSingleton.decIndent();
			SSingleton.addNL("}");
		}
		writeSingStr();
	}

	private void genAlarmActions(HighlevelConfiguration_Counter ctr) {
		for(int i=0; i<ctr.numChildren(); i++) {
			HighlevelConfiguration_Alarm alrm = ctr.getChild(i);

			SSingleton.incIndent();
			SSingleton.addNL("if(AlarmTicks(" + alrm.getName() + ") == CntrCurrentValue(i)) {");
			alrm.getEvent().generateCode();
			SSingleton.newLine();
			SSingleton.incIndent();
			SSingleton.addNL("if(AlarmCycle(" + alrm.getName() + ") > 0) {");
			SSingleton.addNL("AlarmTicks(" + alrm.getName() + ") += AlarmCycle(" + alrm.getName() + ");");
			SSingleton.incIndent();
			SSingleton.addNL("if(AlarmTicks(" + alrm.getName() + ") > CntrMaxValue(i))");
			SSingleton.decIndent();
			SSingleton.decIndent();
			SSingleton.addNL("AlarmTicks(" + alrm.getName() + ") -= CntrMaxValue(i);");
			SSingleton.decIndent();
			SSingleton.addNL("} else AlarmTicks(" + alrm.getName() + ") = 0;");
			SSingleton.addNL("}");
		}
	}
}
