/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

import java.io.*;
import java.util.Enumeration;

public class CodeHook_osc_main_preschedule extends CodeHook_Standard {
	public void fireImmediately() {
		StringBuffer s;
		if (cmdLine.isDefined("timer")) writeLine("	settimer();");
		if (conf.hooks.startup) writeLine("	StartupHook();");
		
		for(Enumeration<HighlevelConfiguration_Task> e = conf.getTasks();
				e.hasMoreElements(); ) {
			HighlevelConfiguration_Task tobj = e.nextElement();
			if (tobj.getAutoactivation()) {
				s = new StringBuffer("	activatetask(");
				s.append(tobj.getName());
				s.append(");");
				writeLine(new String(s));
			}
		}
	}
}

