/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

import josek.idmap.Getter;

import java.io.*;
import java.util.Enumeration;

public class CodeHook_osc_tasks extends CodeHook_Standard {
	public void fireImmediately() {
		StringBuffer s;

		// Task stacks, needed only in ECC systems
		if (cmdLine.isDefined("have_ecc")) {
			throw new RuntimeException("ECC not yet supported");
/*
			for (int i = 0; i < conf.getTaskCount(); i++) {
				s = new StringBuffer("static unsigned char STACK_");
				s.append(conf.getTask(i).getName());
				s.append("[STACKSIZE_TASK_");
				s.append(conf.getTask(i).getName());
				s.append("];");
				writeLine(new String(s));

			}
*/
		}
		if(!cmdLine.isDefined("have_tasks")) return;

		writeLine("");

		// launch function array
		{
		Getter<HighlevelConfiguration_Task> gobj =
			new Getter<HighlevelConfiguration_Task>() {
				public String get(HighlevelConfiguration_Task t) {
					return "JOSEK_TASK_" + t.getName();
				}
			};
		writeLine(conf.taskPrioMapper().writeChildIndexedArray("const LaunchFunctionType __JOSEK_launch_functions", gobj));
		}

		// task flags array
		if(cmdLine.isDefined("have_task_flags")) {
			Getter<HighlevelConfiguration_Task> gobj =
				new Getter<HighlevelConfiguration_Task>() {
					public String get(HighlevelConfiguration_Task t) {
						if( t.preemptive() ) {
							return "JOSEK_TFLAG_PREEMPT";
						}
						return "0";
					}
				};
			writeLine(conf.taskPrioMapper().writeChildIndexedArray("const uint8_t __JOSEK_task_flags", gobj));
		}

		if(cmdLine.isDefined("have_multi_act")) {
			/* We use a downwards counter, so we don't have to maintain
			 * the number of maximum activations in addition to the
			 * activation counter itself when we also have readyqueues.
			 */
			Getter<HighlevelConfiguration_Task> gobj =
				new Getter<HighlevelConfiguration_Task>() {
					public String get(HighlevelConfiguration_Task t) {
						Integer i = new Integer(t.getMaxActivation());
						return i.toString();
					}
				};
			writeLine(conf.taskPrioMapper().writeChildIndexedArray("const uint8_t __JOSEK_task_maxact", gobj));
			writeLine(conf.taskPrioMapper().writeChildIndexedArray("uint8_t __JOSEK_task_actcounter", gobj));
		}
		writeLine("");
	}
}
