/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

import java.io.*;
import java.util.Iterator;

public class CodeHook_osh_prototypes extends CodeHook_Standard {
	public void fireImmediately() {
		if (conf.hooks.startup) writeLine("void StartupHook(void);");
		if (conf.hooks.preTask) writeLine("void PreTaskHook(void);");
		if (conf.hooks.postTask) writeLine("void PostTaskHook(void);");
		if (conf.hooks.error) writeLine("void ErrorHook(void);");
		if (conf.hooks.shutdown) writeLine("void ShutdownHook(void);");
		if (conf.hooks.preISR) writeLine("void PreISRHook(void);");
		if (conf.hooks.postISR) writeLine("void PostISRHook(void);");

		for(Iterator<HighlevelConfiguration_Counter> it=conf.getCounterIterator();
				it.hasNext(); ) {
			HighlevelConfiguration_Counter ctr = it.next();
			for (int i = 0; i < ctr.numChildren(); i++) {
				if (ctr.getChild(i).getEvent() instanceof AlarmEvent_Callback) {
					SSingleton.clear();
					SSingleton.add("void JOSEK_CALLBACK_");
					SSingleton.add(((AlarmEvent_Callback)(ctr.getChild(i).getEvent())).getFuncName());
					SSingleton.add("(void);");
					writeSingStr();
				}
			}
		}

		if(cmdLine.getArchitecture().hasLinux()) {
			if (conf.haveIOISRs()) writeLine("void JOSEK_ISR_IO(int __signalname);");
			for (int i = 0; i < conf.getISRCount(); i++) {
				SSingleton.clear();
				SSingleton.add("void JOSEK_ISR_");
				SSingleton.add((conf.getISR(i).getName()));
				SSingleton.add("(int __signalname);");
				writeSingStr();
			}
		}
	}
}
