/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

import josek.idmap.IDMapChildObject;

public class HighlevelConfiguration_Alarm extends IDMapChildObject<HighlevelConfiguration_Counter> {
	private String basedOnCounter;
	private AlarmEvent event;
	private boolean autoStart;
	private int alarmTime;
	private int cycleTime;
	
	HighlevelConfiguration_Alarm(String name, String basedOnCounter,
			int alarmTime, int cycleTime, boolean autoStart, AlarmEvent event) {
		super(-1,name);
		this.basedOnCounter = basedOnCounter;
		this.alarmTime = alarmTime;
		this.cycleTime = cycleTime;
		this.autoStart = autoStart;
		this.event = event;
		System.err.println(toString());
	}

	public String getBaseCounterName() {
		return basedOnCounter;
	}

	public AlarmEvent getEvent() {
		return event;
	}

	public int getAlarmTime() {
		return alarmTime;
	}
	
	public int getCycleTime() {
		return cycleTime;
	}

	public String toString() {
		return "Alarm '" + name + "' (" + alarmTime + " / " + cycleTime + ") based on " + basedOnCounter + ": " + event;
	}
};

