/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/

package josek;

import josek.parser.*;
import java.io.*;

public class JOsek {

	public static void main(String[] args) {
		SSingleton.init();
		
		CommandLineOptions cmdLine = new CommandLineOptions(args);

		if (cmdLine.getCommandFile() == null) {
			System.err.println("Error: No OIL file given.");
			System.exit(-1);
		}

		Configuration c = ConfigReader.parseDefinition(cmdLine.getCommandFile());
		HighlevelConfiguration h = new HighlevelConfiguration(c, cmdLine);

		if (cmdLine.getGenerateResourceStatistics()) h.dumpConfiguration();

		try {
			CodeGenerator g = new CodeGenerator(h, cmdLine);
			g.generate();
		} catch (IOException e) {
			System.err.println("Error while generating code: " + e);
			System.exit(-1);
		}

		System.out.println("Recommended CFlags: ");
		System.out.println(cmdLine.getArchitecture().getCFlags());
	}
}

