/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek;

class SSingleton {
	private static StringBuffer s;
	private static int indention;

	public static void clear() {
		s.delete(0, s.length());
		if (indention > 0) {
			for (int i = 0; i < indention; i++) add("\t");
		}
	}

	public static void incIndent() {
		indention++;
	}

	public static void decIndent() {
		indention--;
	}

	public static void setIndent(int i) {
		indention = i;
	}

	public static void add(String n) {
		s.append(n);
	}
	
	public static void add(int n) {
		s.append(n);
	}

	public static StringBuffer get() {
		return s;
	}

	public static void newLine() {
		add("\n");
		if (indention > 0) {
			for (int i = 0; i < indention; i++) add("\t");
		}
	}

	public static void addNL(String n) {
		add(n);
		newLine();
	}
	
	public static void init() {
		s = new StringBuffer();
		indention = 0;
	}
}
