/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
StatusType GetTaskState(TaskType TaskID, TaskStateRefType State) {

}

void schedule(uint8_t term) {
	PriorityType priority, priolvl;
	TaskType new_task;

//? assertions
	assert((term == 0) || (term == 1), "schedule: invalid parameter");
//?
	/* If no task applicable, schedule idle task */
	priority = -1;
	new_task = TID_IDLE_TASK;

	/* Find a matching task */
	/* Which is the task priority that is runnable? */
	priority = bitsearch_reverse(taskprio_runnable[priolvl]) + (8 * sizeof(MACHINEWORD) * priolvl) - 1;
	for (i = 0; i < queues[priority].size; i++) {
		/* found a not empty queue! */
		uint8_t position;
		if (queues[priority].write >= queues[priority].size) position = queues[priority].write - queues[priority].size + i;
		else position = queues[priority].write + QUEUE_LENGTH - queues[priority].size + i;
//? debug
		fprintf(stderr, "[DEBUG] Looking into queue %d, element %d (mem %d): TID %d\n", priority, i, position, queues[priority].elements[position].tid);
//?
		if (taskdesc[queues[priority].elements[position].tid].state == READY) {
			new_task = queues[priority].elements[position].tid;
			break;
		}
	}

//? debug
	fprintf(stderr, "[DEBUG] Scheduler: %d => %d (Term = %d)\n", current_task, new_task, term);
//?
	if ((new_task != current_task) || (term)) {
		uint8_t ot = current_task;

		current_priority = priority + 1;

//+ osc_schedule_posttaskhook
		current_task = new_task;
//+ osc_schedule_pretaskhook
		if (term == 0) {
//? debug
			fprintf(stderr, "[DEBUG] Switchtask: %p => %p\n", taskdesc[ot].stack, taskdesc[new_task].stack);
//?
			switchtask(&taskdesc[ot].stack, taskdesc[new_task].stack);
		} else {
//? debug
			fprintf(stderr, "[DEBUG] Dispatch: %p\n", taskdesc[new_task].stack);
//?
			dispatch(taskdesc[new_task].stack);
		}
		return;
	}

	/* Schedule Idle Task */
}

