/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
StatusType GetAlarmBase(AlarmType aid, AlarmBaseRefType info) {
	info->maxallowedvalue = CntrMaxValue(BaseCounter(aid));
	info->ticksperbase = CntrTickMaxValue(BaseCounter(aid));
//? have_extstatus
	info->mincycle = 0; /* TODO */
//?
	return E_OK;
}

StatusType GetAlarm(AlarmType aid, TickRefType tick) {
	TickType atick = AlarmTicks(aid);
	TickType cntr = CntrCurrentValue(BaseCounter(aid));
	if(AlarmTicks(aid)==0)
		return E_OS_NOFUNC;

	if(atick>=cntr)
		*tick = atick-cntr;
	else
		*tick = atick + (CntrMaxValue(BaseCounter(aid))-cntr);
	return E_OK;
}

StatusType SetRelAlarm(AlarmType aid, TickType increment, TickType cycle) {
	TickType cntr, cmax;
	if (AlarmTicks(aid) != 0) return E_OS_STATE;  				/* Alarm already in use */
	if (aid > //?maxAlarm?//) return E_OS_ID;							/* EO: Alarm ID invalid */

	cntr = CntrCurrentValue(BaseCounter(aid));
	cmax = CntrMaxValue(BaseCounter(aid));
		
	AlarmCycle(aid) = cycle;
	
	if(cmax-increment < cntr)
		AlarmTicks(aid) = increment-(cmax - cntr);
	else
		AlarmTicks(aid) = cntr+increment;
	
	return E_OK;
}

StatusType SetAbsAlarm(AlarmType aid, TickType start, TickType cycle) {
	if (AlarmTicks(aid) != 0) return E_OS_STATE;					/* Alarm already in use */
	if (aid > //?maxAlarm?//) return E_OS_ID;							/* EO: Alarm ID invalid */

	AlarmCycle(aid) = cycle;
	AlarmTicks(aid) = start;
	return E_OK;
}

StatusType CancelAlarm(AlarmType aid) {
	if (AlarmTicks(aid) == 0) return E_OS_NOFUNC;	/* Alarm already stopped */
	if (aid > //?maxAlarm?//) return E_OS_ID;	    /* EO: Alarm ID invalid */
	AlarmTicks(aid) = 0;
	return E_OK;
}

