/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
//? have_tasks
extern void schedule(uint8_t);
#define Schedule() schedule(0)

//? have_extstatus || mixed_scheduling
StatusType ActivateTask(TaskType id);
//!
StatusType ActivateTask(TaskType id);
//?
//? have_extstatus || have_ecc
uint8_t TerminateTask(void);
uint8_t ChainTask(TaskType tid);
//!
uint8_t TerminateTask(void);
uint8_t ChainTask(TaskType tid);
//?
//?

//? have_resources
uint8_t GetResource(ResourceType res);
uint8_t ReleaseResource(ResourceType res);
//?

void ShutdownOS(StatusType status) __attribute__ ((noreturn));

//? have_ecc
extern void switchtask(void **old, void **new);
extern void dispatch(void **new);
StatusType SetEvent(TaskType id, EventMaskType mask);
StatusType ClearEvent(EventMaskType mask);
StatusType GetEvent(TaskType id, EventMaskType *mask);
StatusType WaitEvent(EventMaskType mask);
//?
//? have_ioisr
StatusType SetupIOISR(int32_t fd, int32_t isrlvl, uint8_t target);
//?

//? have_alarms
StatusType GetAlarmBase(AlarmType aid, AlarmBaseRefType info);
StatusType GetAlarm(AlarmType aid, TickRefType tick);
StatusType SetRelAlarm(AlarmType aid, TickType increment, TickType cycle);
StatusType SetAbsAlarm(AlarmType aid, TickType start, TickType cycle);
StatusType CancelAlarm(AlarmType aid);
//?
