/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
static unsigned int SINestLevel=0;
static sigset_t SImask;

void SuspendAllInterrupts() {
	sigset_t fullset;
	sigset_t origset;
	
	sigfillset(&fullset);
	sigprocmask(SIG_BLOCK, &fullset, &origset);
	
	if(0 == SINestLevel++) {
		SImask = origset;
	} else {
		printf("NESTING LEVEL %d", SINestLevel);
	}
}

void ResumeAllInterrupts() {
	if(0 == --SINestLevel) {
		sigprocmask(SIG_SETMASK, &SImask, NULL);
	}
}

void DisableAllInterrupts() {
	sigset_t fullset;
	sigfillset(&fullset);
	sigprocmask(SIG_BLOCK, &fullset, NULL);
}

void EnableAllInterrupts() {
	sigset_t fullset;
	sigfillset(&fullset);
	sigprocmask(SIG_UNBLOCK, &fullset, NULL);
}

