/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek.idmap;

import java.util.Vector;

public abstract class IDMapBaseObject<T extends IDMapChildObject> extends IDMapObject {
	protected Vector<T> children;

	public IDMapBaseObject(int eid, String name) {
		super(eid, name);
		children = new Vector<T>();
	}

	public int numChildren() { return children.size(); }

	void addChild(T child) {
		children.add(child);
	}

	public T getChild(int index) {
		return children.get(index);
	}

	public String toString() {
		StringBuffer s = new StringBuffer(100);
		s.append(super.toString());
		s.append("\n");

		for(int i=0; i < numChildren(); i++) {
			s.append("\t=> ");
			s.append(getChild(i).toString());
			s.append("\n");
		}
		return s.toString();
	}
}

