/**(c)

  Copyright (C) 2006, 2007, 2008, 2009 Michael Stilkerich, Johannes Bauer, Christian Wawersich 

  This file is part of the JOSEK operating system.

	JOSEK is free software: you can redistribute it and/or modify it under the
  terms of the Lesser GNU General Public License as published by the Free
  Software Foundation, either version 3 of the License, or (at your option)
  any later version.

	JOSEK is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
  more details. You should have received a copy of the GNU Lesser General
  Public License along with JOSEK. If not, see <http://www.gnu.org/licenses/>.

  Please contact keso@cs.fau.de for more info.

  (c)**/
package josek.idmap;

import java.util.Iterator;
import java.util.Enumeration;

final class MapperIdentical implements Mapper {
	MapperIdentical() { }

	/**
	 * Mapping only possible with 1:1 relations.
	 */
	public int cost(IDMap idm) {
		if(idm.getMaxCPB()==1 && idm.getMinCPB()==1)
			return 0;
		return -1;
	}

	public void map(IDMap idm) {
		int baseid = idm.getMinBaseID()-1;
		for(Iterator<IDMapBaseObject> it = idm.baseIterator(); it.hasNext(); ) {
			IDMapBaseObject base = it.next();
			baseid++;
			base.setInternalID(baseid);
			base.getChild(0).setInternalID(baseid);
		}
		idm.setReverseMapMacro("#define " + idm.reverseMapMacroName() + "(cid) cid");
		idm.cmdLine.verbln("Identical Encoding used for " + idm.mapperName() + " runtime mapping");
		idm.setMaxID(baseid, baseid);
	}

	public String writeChildIndexedArray(String typeAndName, IDMap idm, Getter gobj) {
		StringBuffer s = new StringBuffer(typeAndName);
		s.append("[");
		s.append((idm.getMaxChildID()+1));
		s.append("] = { ");
		for(Enumeration<IDMapChildObject> e=idm.childElements(); e.hasMoreElements(); ) {
			s.append(gobj.get(e.nextElement()));
			s.append(",");
		}
		s.replace(s.length()-1,s.length()," };");
		return s.toString();
	}
}
